package com.sztzjy.fund_investment.config.security;

import io.swagger.models.auth.In;
import lombok.Getter;
import lombok.Setter;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.userdetails.UserDetails;

import java.util.Collection;
import java.util.List;
import java.util.Objects;

/**
 * jwt用户对象
 */
@Getter
@Setter
public class JwtUser implements UserDetails {
    private String username;
    private String password;
    private String name;
    private String userId;
    private int roleId;
    private Integer schoolId;
    private int classId;
    private String schoolName;
    private String className;
    private int majorId;
    private String majorName;
    private int collegeId;
    private String collegeName;
    private List<String> authorityCodes;

    @Override
    public Collection<? extends GrantedAuthority> getAuthorities() {
        return null;
    }

    @Override
    public boolean isAccountNonExpired() {
        return false;
    }

    @Override
    public boolean isAccountNonLocked() {
        return false;
    }

    @Override
    public boolean isCredentialsNonExpired() {
        return false;
    }

    @Override
    public boolean isEnabled() {
        return false;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof JwtUser)) return false;
        JwtUser user = (JwtUser) o;
        return username.equals(user.username);
    }

    @Override
    public int hashCode() {
        return Objects.hash(username);
    }
}
