package com.sztzjy.fund_investment.controller;

import com.sztzjy.fund_investment.annotation.AnonymousAccess;
import com.sztzjy.fund_investment.entity.ProfitManagement;
import com.sztzjy.fund_investment.service.ProfitManagementService;
import com.sztzjy.fund_investment.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Author xcj
 * @Date 2023/11/23
 */
@RestController
@RequestMapping("/stu/profitManagement")
@Api(tags = "学生端--收益管理相关接口")
public class ProfitManagementController {
    @Autowired
    private ProfitManagementService profitManagementService;


    /*
     * @author xcj
     * @Date 2023/11/23
     */
    @ApiOperation("生成折线图/回显")
    @AnonymousAccess
    @GetMapping("/getLineChart")
    public ResultEntity<List<ProfitManagement>> getLineChart(@RequestParam String flowId) {
        List<ProfitManagement> getLineChart = profitManagementService.getLineChart(flowId);
        return new ResultEntity<>(getLineChart);
    }


    @ApiOperation("退出时机弹窗")
    @AnonymousAccess
    @GetMapping("/getExitTime")   //todo 基金收益 / 投资金额 = 退出时收益率
    public ResultEntity<String> getExitTime(@RequestParam String flowId) {
        return null;
    }


    @ApiOperation("显示股票相关信息弹窗")
    @AnonymousAccess
    @GetMapping("/getStockInfo")
    public ResultEntity<String> getStockInfo(@RequestParam String flowId) {
        return null;
    }


    @ApiOperation("判断市值和基金收益对错")
    @AnonymousAccess
    @GetMapping("/getRightMarketValueAndFundEarnings")
    public ResultEntity<String> getStockInfo(@RequestParam String flowId,
                                             @ApiParam("市值") @RequestParam String marketValue,
                                             @ApiParam("基金收益") @RequestParam String fundEarnings) {
        return null;
    }
}
