package com.sztzjy.fund_investment.controller;

import cn.hutool.core.util.IdUtil;
import com.github.pagehelper.PageInfo;
import com.itextpdf.text.*;
import com.itextpdf.text.Font;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;
import com.sztzjy.fund_investment.annotation.AnonymousAccess;
import com.sztzjy.fund_investment.entity.*;
import com.sztzjy.fund_investment.entity.treeSelect.TreeSelect;
import com.sztzjy.fund_investment.mapper.FoundProjectMapper;
import com.sztzjy.fund_investment.mapper.ProjectPoolMapper;
import com.sztzjy.fund_investment.service.ISysProjectDueDiligenceService;
import com.sztzjy.fund_investment.util.ResultEntity;
import com.sztzjy.fund_investment.util.excel.FilePortUtil;
import com.sztzjy.fund_investment.util.pdfUtils.HeaderAndFooterEvent;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.formula.functions.T;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.*;
import javax.servlet.http.HttpServletResponse;
import java.awt.*;
import java.io.IOException;
import java.util.*;
import java.util.List;


//yz
@RestController
@RequestMapping("/stu/projectDueDiligenceController")
@Api(tags = "学生端--项目尽调")
public class ProjectDueDiligence {
    @Autowired
    ISysProjectDueDiligenceService projectDueDiligenceService;
    @Autowired
    FoundProjectMapper foundProjectMapper;
    @Autowired
    ProjectPoolMapper projectPoolMapper;
    @Autowired
    HeaderAndFooterEvent headerAndFooterEvent;
    //*************公司业务尽职调查

    @GetMapping("getProjectPoolNameByFlowId")
    @ApiOperation("查询公司名称")
    @AnonymousAccess
    public String getProjectPoolNameByFlowId(@ApiParam("流程ID") @RequestParam String flowId) {
        String projectPoolId = foundProjectMapper.selectByPrimaryKey(flowId).getProjectPoolId();
        String companyName = projectPoolMapper.selectByPrimaryKey(projectPoolId).getCompanyName();
        return companyName;
    }


    @GetMapping("getBusinessInfoShareholderList")
    @ApiOperation("公司背景-工商信息上")
    @AnonymousAccess
    public ResultEntity<ProBusinessInfoShareholder> getBusinessInfoShareholderList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProBusinessInfoShareholder> list = projectDueDiligenceService.getBusinessInfoShareholderListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "公司背景-工商信息上，展示成功", list.get(0));
    }

    @GetMapping("getBusinessInfoList")
    @ApiOperation("公司背景-工商信息下")
    @AnonymousAccess
    public ResultEntity<ProBusinessInfo> getBusinessInfoList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProBusinessInfo> list = projectDueDiligenceService.getBusinessInfoList(flowId);
        return new ResultEntity(HttpStatus.OK, "公司背景-工商信息下，展示成功", list.get(0));
    }

    @GetMapping("getProJudicialRiskList")
    @ApiOperation("司法风险")
    @AnonymousAccess
    public ResultEntity<List<ProJudicialRisk>> getProJudicialRiskList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProJudicialRisk> list = projectDueDiligenceService.getProJudicialRiskListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "司法风险，展示成功", list);
    }

    @GetMapping("getProBusinessRiskList")
    @ApiOperation("经营风险")
    @AnonymousAccess
    public ResultEntity<List<ProBusinessRisk>> getProBusinessRiskList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProBusinessRisk> list = projectDueDiligenceService.getProBusinessRiskListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "经营风险，展示成功", list);
    }

    @GetMapping("getProCoreTeamList")
    @ApiOperation("公司发展-核心团队")
    @AnonymousAccess
    public ResultEntity<List<ProCoreTeam>> getProCoreTeamList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProCoreTeam> list = projectDueDiligenceService.getProCoreTeamListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "公司发展-核心团队，展示成功", list);
    }

    @GetMapping("getProCoreBusinessList")
    @ApiOperation("公司发展-核心业务")
    @AnonymousAccess
    public ResultEntity<List<ProCoreBusiness>> getProCoreBusinessList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProCoreBusiness> list = projectDueDiligenceService.getProCoreBusinessListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "公司发展-核心业务，展示成功", list);
    }

    @GetMapping("getProCoreCompProList")
    @ApiOperation("公司发展-相关竞品")
    @AnonymousAccess
    public ResultEntity<List<ProCoreCompPro>> getProCoreCompProList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProCoreCompPro> list = projectDueDiligenceService.getProCoreCompProListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "公司发展-相关竞品，展示成功", list);
    }

    @GetMapping("getProManaSituRecruitList")
    @ApiOperation("经营状况-公司招聘")
    @AnonymousAccess
    public ResultEntity<List<ProManaSituRecruit>> getProManaSituRecruitList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProManaSituRecruit> list = projectDueDiligenceService.getProManaSituRecruitListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "经营状况-公司招聘，展示成功", list);
    }

    @GetMapping("getProManaSituCheckList")
    @ApiOperation("经营状况-抽查检查")
    @AnonymousAccess
    public ResultEntity<List<ProManaSituCheck>> getProManaSituCheckList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProManaSituCheck> list = projectDueDiligenceService.getProManaSituCheckListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "经营状况-抽查检查，展示成功", list);
    }

    @GetMapping("getProManaSituLicenseList")
    @ApiOperation("经营状况-行政许可")
    @AnonymousAccess
    public ResultEntity<List<ProManaSituLicense>> getProManaSituLicenseList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProManaSituLicense> list = projectDueDiligenceService.getProManaSituLicenseListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "经营状况-行政许可，展示成功", list);
    }

    @GetMapping("getProManaSituTenderingBiddingList")
    @ApiOperation("经营状况-招投标")
    @AnonymousAccess
    public ResultEntity<List<ProManaSituTenderingBidding>> getProManaSituTenderingBiddingList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProManaSituTenderingBidding> list = projectDueDiligenceService.getProManaSituTenderingBiddingListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "经营状况-招投标，展示成功", list);
    }

    @GetMapping("getProIntelPropertyPatentInfoList")
    @ApiOperation("知识产权-专利信息")
    @AnonymousAccess
    public ResultEntity<List<ProIntelPropertyPatentinfo>> getProIntelPropertyPatentInfoList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProIntelPropertyPatentinfo> list = projectDueDiligenceService.getProIntelPropertyPatentInfoListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "知识产权-专利信息，展示成功", list);
    }

    @GetMapping("getProIntelPropertyWebsiteRecordList")
    @ApiOperation("知识产权-网站备案")
    @AnonymousAccess
    public ResultEntity<List<ProIntelPropertyWebsiteRecord>> getProIntelPropertyWebsiteRecordList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProIntelPropertyWebsiteRecord> list = projectDueDiligenceService.getProIntelPropertyWebsiteRecordListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "知识产权-网站备案，展示成功", list);
    }

    @GetMapping("getProAdminiPenaltyList")
    @ApiOperation("法律尽职调查-行政处罚【信用中国】")
    @AnonymousAccess
    public ResultEntity<List<ProAdminiPenalty>> getProAdminiPenaltyList(@ApiParam("流程ID") @RequestParam String flowId) {
        List<ProAdminiPenalty> list = projectDueDiligenceService.getProAdminiPenaltyListByFlowId(flowId);
        return new ResultEntity(HttpStatus.OK, "法律尽职调查-行政处罚【信用中国】，展示成功", list);
    }

    @PostMapping("updateServiceDueDiligence")
    @ApiOperation("业务尽调结论")
    @AnonymousAccess
    public ResultEntity updateServiceDueDiligence(@ApiParam("转递flow_id、service_due_diligence") @RequestBody FoundProject foundProject) {
        if (StringUtils.isBlank(foundProject.getFlowId())) {
            return new ResultEntity(HttpStatus.BAD_REQUEST, "流程ID为空");
        }
        if (StringUtils.isBlank(foundProject.getServiceDueDiligence())) {
            return new ResultEntity(HttpStatus.BAD_REQUEST, "业务尽调结论为空");
        }
        projectDueDiligenceService.updateServiceDueDiligence(foundProject);
        return new ResultEntity(HttpStatus.OK, "业务尽调结论保存成功");
    }

    @GetMapping("getServiceDueDiligence")
    @ApiOperation("业务尽调结论回显")
    @AnonymousAccess
    public ResultEntity<FoundProject> getServiceDueDiligence(@ApiParam("流程ID") @RequestParam String flowId) {
        FoundProject foundProject = foundProjectMapper.selectByPrimaryKey(flowId);
        foundProject.setFinancialDueDiligence(null);
        foundProject.setFoundProjectConclusion(null);
        return new ResultEntity(HttpStatus.OK, "业务尽调结论，展示成功", foundProject);
    }


    //*********************公司财务尽职调查


    @GetMapping("getProFinancialIndexSelectTree")
    @ApiOperation("财务指标选取下拉框")
    @AnonymousAccess
    public ResultEntity<List<TreeSelect>> getProFinancialIndexSelectTree() {
        List<TreeSelect> list = projectDueDiligenceService.getProFinancialIndexSelectTree();
        return new ResultEntity(HttpStatus.OK, "财务指标选取下拉框，展示成功", list);
    }

    @GetMapping("getProFinancialStatementSelectTree")
    @ApiOperation("财务报表选取下拉框")
    @AnonymousAccess
    public ResultEntity<List<TreeSelect>> getProFinancialStatementSelectTree() {
        List<TreeSelect> list = projectDueDiligenceService.getProFinancialStatementSelectTree();
        return new ResultEntity(HttpStatus.OK, "财务报表选取下拉框，展示成功", list);
    }

    @GetMapping("selectProFinancialIndexDetailList")
    @ApiOperation("财务指标查询")
    @AnonymousAccess
    public ResultEntity<PageInfo<ProFinancialIndexDetail>> selectProFinancialIndexDetailList(@ApiParam("节点id的集合List") @RequestParam List<String> proFinancialIndexIdList,
                                                          @ApiParam("流程ID") @RequestParam String flowId,
                                                          @ApiParam("条数") @RequestParam Integer size,
                                                          @ApiParam("页数") @RequestParam Integer index) {
        PageInfo<ProFinancialIndexDetail> pageInfo = projectDueDiligenceService.selectProFinancialIndexDetailList(proFinancialIndexIdList, flowId, size, index);
        return new ResultEntity(HttpStatus.OK, "财务指标查询成功", pageInfo);
    }

    @GetMapping("selectProFinancialStatementDetailList")
    @ApiOperation("财务报表查询")
    @AnonymousAccess
    public ResultEntity<PageInfo<ProFinancialStatementDetail>> selectProFinancialStatementDetailList(@ApiParam("节点id的集合List") @RequestParam List<String> proFinancialStatementIdList,
                                                              @ApiParam("流程ID") @RequestParam String flowId,
                                                              @ApiParam("条数") @RequestParam Integer size,
                                                              @ApiParam("页数") @RequestParam Integer index) {
        PageInfo<ProFinancialStatementDetail> pageInfo = projectDueDiligenceService.selectProFinancialStatementDetailList(proFinancialStatementIdList, flowId, size, index);
        return new ResultEntity(HttpStatus.OK, "财务报表查询成功", pageInfo);
    }

    @GetMapping("exportProFinancialIndexDetailList")
    @ApiOperation("财务指标选取导出")
    @AnonymousAccess
    public void exportProFinancialIndexDetailList(@ApiParam("HttpServletResponse") HttpServletResponse response,
                                                      @ApiParam("节点id的集合List") @RequestParam List<String> proFinancialIndexIdList,
                                                      @ApiParam("流程ID") @RequestParam String flowId) {
        //导出的表名
        String title = IdUtil.simpleUUID();
        //表中第一行表头字段
        String[] headers = null;
        List<String> listColumn;
        headers = new String[]{"指标名称", "2022/12/31", "2021/12/31", "2020/12/31"};
        listColumn = Arrays.asList("name", "lastYearValue", "lastTowYearValue", "lastThreeYearValue");
        //实际数据结果集
        PageInfo<ProFinancialIndexDetail> pageInfo = projectDueDiligenceService.selectProFinancialIndexDetailList(proFinancialIndexIdList, flowId, 10000, 1);
        List<ProFinancialIndexDetail> list = pageInfo.getList();
        //具体需要写入excel需要哪些字段，这些字段取自UserReward类，也就是上面的实际数据结果集的泛型

        try {
            FilePortUtil.exportExcel(response, title, headers, list, listColumn);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @GetMapping("exportProFinancialStatementDetailList")
    @ApiOperation("财务报表选取导出")
    @AnonymousAccess
    public void exportProFinancialStatementDetailList(@ApiParam("HttpServletResponse") HttpServletResponse response,
                                                      @ApiParam("节点id的集合List") @RequestParam List<String> proFinancialStatemantIdList,
                                                      @ApiParam("流程ID") @RequestParam String flowId) {
        //导出的表名
        String title = IdUtil.simpleUUID();
        //表中第一行表头字段
        String[] headers = null;
        List<String> listColumn;
        headers = new String[]{"指标名称", "2022/12/31", "2021/12/31", "2020/12/31"};
        listColumn = Arrays.asList("name", "lastYearValue", "lastTowYearValue", "lastThreeYearValue");
        //实际数据结果集
        PageInfo<ProFinancialStatementDetail> pageInfo = projectDueDiligenceService.selectProFinancialStatementDetailList(proFinancialStatemantIdList, flowId, 10000, 1);
        List<ProFinancialStatementDetail> list = pageInfo.getList();
        //具体需要写入excel需要哪些字段，这些字段取自UserReward类，也就是上面的实际数据结果集的泛型

        try {
            FilePortUtil.exportExcel(response, title, headers, list, listColumn);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    @PostMapping("updateFinanceDueDiligence")
    @ApiOperation("财务尽调结论")
    @AnonymousAccess
    public ResultEntity updateFinanceDueDiligence(@ApiParam("转递flow_id、financialDueDiligence") @RequestBody FoundProject foundProject) {
        if (StringUtils.isBlank(foundProject.getFlowId())) {
            return new ResultEntity(HttpStatus.BAD_REQUEST, "流程ID为空");
        }
        if (StringUtils.isBlank(foundProject.getFinancialDueDiligence())) {
            return new ResultEntity(HttpStatus.BAD_REQUEST, "财务尽调结论为空");
        }
        projectDueDiligenceService.updateServiceDueDiligence(foundProject);
        return new ResultEntity(HttpStatus.OK, "财务尽调结论保存成功");
    }

    @GetMapping("getFinanceDueDiligence")
    @ApiOperation("财务尽调结论回显")
    @AnonymousAccess
    public ResultEntity<FoundProject> getFinanceServiceDueDiligence(@ApiParam("流程ID") @RequestParam String flowId) {
        FoundProject foundProject = foundProjectMapper.selectByPrimaryKey(flowId);
        foundProject.setServiceDueDiligence(null);
        foundProject.setFoundProjectConclusion(null);
        return new ResultEntity(HttpStatus.OK, "财务尽调结论，展示成功", foundProject);
    }


    @GetMapping("exportFinanceDueDiligencePDF")
    @ApiOperation("财务尽调生成报告")
    @AnonymousAccess
    public void exportFinanceDueDiligencePDF(@ApiParam("HttpServletResponse") HttpServletResponse response,
                                                     @ApiParam("流程ID") @RequestParam String flowId) throws IOException, DocumentException {
        String projectPoolName=getProjectPoolNameByFlowId(flowId);  //公司名称

        Document document = new Document();
        // 创建 PdfWriter 对象 第一个参数是对文档对象的引用，第二个参数是文件的实际名称，在该名称中还会给出其输出路径。
        PdfWriter writer = PdfWriter.getInstance(document, response.getOutputStream());
        writer.setPageEvent(new HeaderAndFooterEvent());
        document.open();
        HeaderAndFooterEvent.tpl=writer.getDirectContent().createTemplate(500,500);
        HeaderAndFooterEvent.PAGE_NUMBER = true;//实现页眉跟页脚
        HeaderAndFooterEvent.HeaderLeft = "";//左上角
        HeaderAndFooterEvent.HeaderRight = "";//右上角
        HeaderAndFooterEvent.FooterLeft = "";//左下角
        HeaderAndFooterEvent.FooterRight= "深圳市天择教育科技有限公司";//右下角
        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "宋体", 25, Font.BOLD);
        //添加一个空段落来占位，五个参数分别为：内容，对齐方式（1为居中，0为居左，2为居右），段后空行数，段前空行数，行间距
        document.add(HeaderAndFooterEvent.AddParagraph(" ", 1, 200, 0, 1.5f));
        document.add(HeaderAndFooterEvent.AddParagraph("天择投资银行业务教学系统", 1, 1.5f));
        HeaderAndFooterEvent.SetFont(BaseColor.GRAY, "宋体", 18, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph(projectPoolName + "--尽职调查报告", 1, 1.5f));

        document.newPage();  //换第二页 目录
        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 22, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("目录", 1, 1.5f));

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p1 = HeaderAndFooterEvent.AddParagraph("一、公司背景：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p1.add(HeaderAndFooterEvent.AddParagraph("公司名称、法定代表人、股东及持股比例、成立日期、注册资本、\n" +
                "经营状态、统一社会信用代码、纳税人识别号、营业期限、实缴资本、参保人数、注\n" +
                "册地址、经营范围、工商注册号、组织机构代码、公司类型、行业、核准日期、人员\n" +
                "规模、登记机关 ", 0, 1.5f));
        document.add(p1);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p2 = HeaderAndFooterEvent.AddParagraph("二、司法风险：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p2.add(HeaderAndFooterEvent.AddParagraph("开庭日期、案号、案由、公诉人/原告、被告人", 0, 1.5f));
        document.add(p2);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p3 = HeaderAndFooterEvent.AddParagraph("三、经营风险：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p3.add(HeaderAndFooterEvent.AddParagraph("列入经营异常名录原因、列入日期、列入机关；移出经营异常名录\n" +
                "原因、移出日期、移出机关 ", 0, 1.5f));
        document.add(p3);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p4 = HeaderAndFooterEvent.AddParagraph("四、公司发展：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p4.add(HeaderAndFooterEvent.AddParagraph("核心团队、核心业务、相关竞品", 0, 1.5f));
        document.add(p4);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p5 = HeaderAndFooterEvent.AddParagraph("五、经营状况：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p5.add(HeaderAndFooterEvent.AddParagraph("公司招聘、抽查检查、行政许可、招投标 ", 0, 1.5f));
        document.add(p5);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p6 = HeaderAndFooterEvent.AddParagraph("六、知识产权：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p6.add(HeaderAndFooterEvent.AddParagraph("专利信息、网站备案", 0, 1.5f));
        document.add(p6);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p7 = HeaderAndFooterEvent.AddParagraph("七、法律尽职调查：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p7.add(HeaderAndFooterEvent.AddParagraph("行政处罚", 0, 1.5f));
        document.add(p7);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p8 = HeaderAndFooterEvent.AddParagraph("八、财务尽职调查：", 0, 1.5f);
        HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 14, Font.BOLD);
        p8.add(HeaderAndFooterEvent.AddParagraph("三大财务报表、主要财务指标", 0, 1.5f));
        document.add(p8);

        document.newPage();  //换第三页


        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p11 = HeaderAndFooterEvent.AddParagraph("一、公司背景", 0, 1.5f);//公司背景
        document.add(p11);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("工商信息：", 0, 1.5f));//工商信息
        ProBusinessInfoShareholder proBusinessInfoShareholder = projectDueDiligenceService.getBusinessInfoShareholderListByFlowId(flowId).get(0);
        ProBusinessInfo proBusinessInfo = projectDueDiligenceService.getBusinessInfoList(flowId).get(0);
        TreeMap<String,String> treeMap=new TreeMap<>();
        treeMap.put("企业名称",projectPoolName);
        treeMap.put("法定代表人",proBusinessInfoShareholder.getLegalPerson());
        treeMap.put("股东",proBusinessInfoShareholder.getShareholder1());
        treeMap.put("持股比例",proBusinessInfoShareholder.getValue1());
        treeMap.put("注册资本",proBusinessInfo.getRegisteredCapital());
        treeMap.put("经营状态",proBusinessInfo.getOperatingState());
        treeMap.put("统一社会信用代码",proBusinessInfo.getCreditCode());
        treeMap.put("纳税人识别号",proBusinessInfo.getIdentificationNumber());
        treeMap.put("营业期限",proBusinessInfo.getBusinessTerm());
        treeMap.put("实缴资本",proBusinessInfo.getPaidinCapital());
        treeMap.put("参保人数",proBusinessInfo.getInsuranceNum());
        treeMap.put("成立日期",proBusinessInfo.getCreateDate());
        treeMap.put("工商注册号",proBusinessInfo.getRegistrationNum());
        treeMap.put("组织机构代码",proBusinessInfo.getOrgaStruCode());
        treeMap.put("公司类型",proBusinessInfo.getCompanyType());
        treeMap.put("行业",proBusinessInfo.getIndustry());
        treeMap.put("核准日期",proBusinessInfo.getApprovalDate());
        treeMap.put("人员规模",proBusinessInfo.getStaffSize());
        treeMap.put("登记机关",proBusinessInfo.getRegistrar());
        treeMap.put("注册地址",proBusinessInfo.getRegisteredAddress());
        treeMap.put("经营范围",proBusinessInfo.getBusinessScope());
        PdfPTable table = returnPdfPTable(treeMap);
        document.add(table);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p12 = HeaderAndFooterEvent.AddParagraph("二、司法风险", 0, 1.5f);
        document.add(p12);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("司法风险：", 0, 1.5f));
        ProJudicialRisk proJudicialRisk = projectDueDiligenceService.getProJudicialRiskListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap2=new TreeMap<>();
        treeMap2.put("开庭日期",proJudicialRisk.getLawfulDay());
        treeMap2.put("案号",proJudicialRisk.getCaseCode());
        treeMap2.put("案由",proJudicialRisk.getCause());
        treeMap2.put("公诉人/原告",proJudicialRisk.getPlaintiff());
        treeMap2.put("被告人",proJudicialRisk.getDefendant());
        PdfPTable table2 = returnPdfPTable(treeMap2);
        document.add(table2);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p13 = HeaderAndFooterEvent.AddParagraph("三、经营风险", 0, 1.5f);
        document.add(p13);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("经营风险:", 0, 1.5f));
        ProBusinessRisk proBusinessRisk = projectDueDiligenceService.getProBusinessRiskListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap3=new TreeMap<>();
        treeMap3.put("列入日期 ",proBusinessRisk.getIncludedDate());
        treeMap3.put("列入经营异常名录原因",proBusinessRisk.getIncludedCause());
        treeMap3.put("列入机关 ",proBusinessRisk.getIncludedOrganization());
        treeMap3.put("移出日期",proBusinessRisk.getRemovedDate());
        treeMap3.put("移出经营异常名录原因",proBusinessRisk.getRemovedCause());
        treeMap3.put("移出决定机关 ",proBusinessRisk.getRemovedOrganization());
        PdfPTable table3 = returnPdfPTable(treeMap3);
        document.add(table3);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p14 = HeaderAndFooterEvent.AddParagraph("四、公司发展", 0, 1.5f);
        document.add(p14);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("核心团队：", 0, 1.5f));
        ProCoreTeam proCoreTeam = projectDueDiligenceService.getProCoreTeamListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap4=new TreeMap<>();
        treeMap4.put("姓名",proCoreTeam.getName());
        treeMap4.put("职位",proCoreTeam.getDuty());
        treeMap4.put("简介",proCoreTeam.getIntroduction());
        PdfPTable table4 = returnPdfPTable(treeMap4);
        document.add(table4);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("核心业务：", 0, 1.5f));
        ProCoreBusiness proCoreBusiness = projectDueDiligenceService.getProCoreBusinessListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap42=new TreeMap<>();
        treeMap42.put("产品名称",proCoreBusiness.getProductnameName());
        treeMap42.put("行业",proCoreBusiness.getIndustry());
        treeMap42.put("产品介绍",proCoreBusiness.getProductIntroduction());
        PdfPTable table42 = returnPdfPTable(treeMap42);
        document.add(table42);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("相关竞品：", 0, 1.5f));
        ProCoreCompPro proCoreCompPro = projectDueDiligenceService.getProCoreCompProListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap43=new TreeMap<>();
        treeMap43.put("竞品名称",proCoreCompPro.getCompProName());
        treeMap43.put("地区",proCoreCompPro.getIndustry());
        treeMap43.put("当前融资轮次",proCoreCompPro.getArea());
        treeMap43.put("行业",proCoreCompPro.getIndustry());
        treeMap43.put("业务",proCoreCompPro.getBusiness());
        treeMap43.put("成立时间",proCoreCompPro.getCreateDate());
        treeMap43.put("估值",proCoreCompPro.getValuation());
        PdfPTable table43 = returnPdfPTable(treeMap43);
        document.add(table43);



        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p15 = HeaderAndFooterEvent.AddParagraph("五、经营状况", 0, 1.5f);
        document.add(p15);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("公司招聘：", 0, 1.5f));
        ProManaSituRecruit proManaSituRecruit = projectDueDiligenceService.getProManaSituRecruitListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap51=new TreeMap<>();
        treeMap51.put("发布日期",proManaSituRecruit.getReleaseDate());
        treeMap51.put("招聘职位",proManaSituRecruit.getDuty());
        treeMap51.put("月薪",proManaSituRecruit.getSalary());
        treeMap51.put("学历",proManaSituRecruit.getDegrees());
        treeMap51.put("工作经验",proManaSituRecruit.getExperience());
        treeMap51.put("地区",proManaSituRecruit.getArea());
        PdfPTable table51 = returnPdfPTable(treeMap51);
        document.add(table51);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("抽查检查：", 0, 1.5f));
        ProManaSituCheck proManaSituCheck = projectDueDiligenceService.getProManaSituCheckListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap52=new TreeMap<>();
        treeMap52.put("日期",proManaSituCheck.getCheckDate());
        treeMap52.put("类型",proManaSituCheck.getCheckType());
        treeMap52.put("结果",proManaSituCheck.getConsequence());
        treeMap52.put("检查实施机关",proManaSituCheck.getOrganization());
        PdfPTable table52 = returnPdfPTable(treeMap52);
        document.add(table52);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("行政许可：", 0, 1.5f));
        ProManaSituLicense proManaSituLicense = projectDueDiligenceService.getProManaSituLicenseListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap53=new TreeMap<>();
        treeMap53.put("行政许可文书号",proManaSituLicense.getWrittenDecisionNum());
        treeMap53.put("许可决定机关",proManaSituLicense.getOrganization());
        treeMap53.put("许可决定日期",proManaSituLicense.getLicenseDate());
        PdfPTable table53 = returnPdfPTable(treeMap53);
        document.add(table53);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("招投标：", 0, 1.5f));
        ProManaSituTenderingBidding proManaSituTenderingBidding = projectDueDiligenceService.getProManaSituTenderingBiddingListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap54=new TreeMap<>();
        treeMap54.put("发布日期",proManaSituTenderingBidding.getReleaseDate());
        treeMap54.put("标题",proManaSituTenderingBidding.getTitle());
        treeMap54.put("采购人",proManaSituTenderingBidding.getPurchaser());
        PdfPTable table54 = returnPdfPTable(treeMap54);
        document.add(table54);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p16 = HeaderAndFooterEvent.AddParagraph("六、知识产权", 0, 1.5f);
        document.add(p16);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("专利信息：", 0, 1.5f));
        ProIntelPropertyPatentinfo proIntelPropertyPatentinfo = projectDueDiligenceService.getProIntelPropertyPatentInfoListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap61=new TreeMap<>();
        treeMap61.put("申请公布日",proIntelPropertyPatentinfo.getPublishDate());
        treeMap61.put("专利名称",proIntelPropertyPatentinfo.getPatentName());
        treeMap61.put("申请号",proIntelPropertyPatentinfo.getApplicationNum());
        treeMap61.put("申请公布号",proIntelPropertyPatentinfo.getApplicationPubNum());
        treeMap61.put("专利类型",proIntelPropertyPatentinfo.getPatentType());
        PdfPTable table61 = returnPdfPTable(treeMap61);
        document.add(table61);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("网站备案：", 0, 1.5f));
        ProIntelPropertyWebsiteRecord proIntelPropertyWebsiteRecord = projectDueDiligenceService.getProIntelPropertyWebsiteRecordListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap62=new TreeMap<>();
        treeMap62.put("审核日期",proIntelPropertyWebsiteRecord.getReviewDate());
        treeMap62.put("网站名称",proIntelPropertyWebsiteRecord.getWebsiteName());
        treeMap62.put("IP地址",proIntelPropertyWebsiteRecord.getIpAddress());
        treeMap62.put("域名信息",proIntelPropertyWebsiteRecord.getDomainNameInfo());
        PdfPTable table62 = returnPdfPTable(treeMap62);
        document.add(table62);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p17 = HeaderAndFooterEvent.AddParagraph("七、法律尽职调查", 0, 1.5f);
        document.add(p17);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("行政处罚：", 0, 1.5f));
        ProAdminiPenalty proAdminiPenalty = projectDueDiligenceService.getProAdminiPenaltyListByFlowId(flowId).get(0);
        TreeMap<String,String> treeMap7=new TreeMap<>();
        treeMap7.put("公司名称",projectPoolName);
        treeMap7.put("决定日期",proAdminiPenalty.getDecisionDate());
        treeMap7.put("决定书文号",proAdminiPenalty.getWrittenDecisionNum());
        treeMap7.put("处罚事由",proAdminiPenalty.getPunishmentCause());
        treeMap7.put("处罚结果",proAdminiPenalty.getPunishmentResult());
        treeMap7.put("处罚机关",proAdminiPenalty.getPunishmentOrganization());
        PdfPTable table7 = returnPdfPTable(treeMap7);
        document.add(table7);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 16, Font.BOLD);
        Paragraph p18 = HeaderAndFooterEvent.AddParagraph("八、财务尽职调查", 0, 1.5f);
        document.add(p18);
        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("指标数据：", 0, 1.5f));
        ArrayList<String> list = new ArrayList<>();
        list.add("7");
        list.add("8");
        list.add("9");
        list.add("10");
        List<ProFinancialIndexDetail> financialIndexDetailList = projectDueDiligenceService.selectProFinancialIndexDetailList(list, flowId, 10, 1).getList();


        PdfPTable table8 = new PdfPTable(4);
        table8.setWidthPercentage(100);//设置表格宽度占用百分比
        List<String> headList1=new ArrayList<>();
        headList1.add("项目");
        headList1.add("2022-12-31");
        headList1.add("2021-12-31");
        headList1.add("2020-12-31");
        PdfPTable table8return = setPdfPTableHead(table8, headList1);
        for (int i = 0; i < financialIndexDetailList.size(); i++) {
            ProFinancialIndexDetail proFinancialIndexDetail = financialIndexDetailList.get(i);
            List<String> headList2=new ArrayList<>();
            headList2.add(proFinancialIndexDetail.getName());
            headList2.add(proFinancialIndexDetail.getLastYearValue());
            headList2.add(proFinancialIndexDetail.getLastTowYearValue());
            headList2.add(proFinancialIndexDetail.getLastThreeYearValue());
            table8return=setPdfPTableHead(table8return, headList2);
        }
        document.add(table8return);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("资产负债表：", 0, 1.5f));
        ArrayList<String> list82 = new ArrayList<>();
        list82.add("51");
        list82.add("52");
        list82.add("53");
        list82.add("54");
        list82.add("55");
        list82.add("56");
        list82.add("57");
        list82.add("58");
        list82.add("59");
        list82.add("60");
        List<ProFinancialStatementDetail> financialStatementDetailList = projectDueDiligenceService.selectProFinancialStatementDetailList(list82, flowId, 10, 1).getList();

        PdfPTable table82 = new PdfPTable(4);
        table82.setWidthPercentage(100);//设置表格宽度占用百分比
        PdfPTable table82return = setPdfPTableHead(table82, headList1);
        for (int i = 0; i < financialStatementDetailList.size(); i++) {
            ProFinancialStatementDetail proFinancialStatementDetail = financialStatementDetailList.get(i);
            List<String> headList82=new ArrayList<>();
            headList82.add(proFinancialStatementDetail.getName());
            headList82.add(proFinancialStatementDetail.getLastYearValue());
            headList82.add(proFinancialStatementDetail.getLastTowYearValue());
            headList82.add(proFinancialStatementDetail.getLastThreeYearValue());
            table82return=setPdfPTableHead(table82return, headList82);
        }
        document.add(table82return);


        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("现金流量表：", 0, 1.5f));
        ArrayList<String> list83 = new ArrayList<>();
        list83.add("136");
        list83.add("137");
        list83.add("138");
        list83.add("139");
        list83.add("140");
        list83.add("141");
        list83.add("142");
        list83.add("143");
        list83.add("144");
        list83.add("145");

        List<ProFinancialStatementDetail> financialStatementDetailList83 = projectDueDiligenceService.selectProFinancialStatementDetailList(list83, flowId, 10, 1).getList();

        PdfPTable table83 = new PdfPTable(4);
        table83.setWidthPercentage(100);//设置表格宽度占用百分比
        PdfPTable table83return = setPdfPTableHead(table83, headList1);
        for (int i = 0; i < financialStatementDetailList83.size(); i++) {
            ProFinancialStatementDetail proFinancialStatementDetail = financialStatementDetailList83.get(i);
            List<String> headList83=new ArrayList<>();
            headList83.add(proFinancialStatementDetail.getName());
            headList83.add(proFinancialStatementDetail.getLastYearValue());
            headList83.add(proFinancialStatementDetail.getLastTowYearValue());
            headList83.add(proFinancialStatementDetail.getLastThreeYearValue());
            table83return=setPdfPTableHead(table83return, headList83);
        }
        document.add(table83return);

        HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 14, Font.BOLD);
        document.add(HeaderAndFooterEvent.AddParagraph("利润表：", 0, 1.5f));
        ArrayList<String> list84 = new ArrayList<>();
        list84.add("12");
        list83.add("13");
        list83.add("14");
        list83.add("15");
        list83.add("16");
        list83.add("17");
        list83.add("18");
        list83.add("19");
        list83.add("20");
        list83.add("21");


        List<ProFinancialStatementDetail> financialStatementDetailList84 = projectDueDiligenceService.selectProFinancialStatementDetailList(list84, flowId, 10, 1).getList();

        PdfPTable table84 = new PdfPTable(4);
        table84.setWidthPercentage(100);//设置表格宽度占用百分比
        PdfPTable table84return = setPdfPTableHead(table84, headList1);
        for (int i = 0; i < financialStatementDetailList84.size(); i++) {
            ProFinancialStatementDetail proFinancialStatementDetail = financialStatementDetailList84.get(i);
            List<String> headList84=new ArrayList<>();
            headList84.add(proFinancialStatementDetail.getName());
            headList84.add(proFinancialStatementDetail.getLastYearValue());
            headList84.add(proFinancialStatementDetail.getLastTowYearValue());
            headList84.add(proFinancialStatementDetail.getLastThreeYearValue());
            table84return=setPdfPTableHead(table84return, headList84);
        }
        document.add(table84return);

        document.close();
    }

    public PdfPTable returnPdfPTable(TreeMap<String,String> treeMap){
        PdfPTable table =new PdfPTable(2);  //两列
        table.setWidthPercentage(100);//设置表格宽度占用百分比
        for (Map.Entry<String, String> entry : treeMap.entrySet()) {
            String key = entry.getKey();
            String value = entry.getValue();
            HeaderAndFooterEvent.SetFont(BaseColor.DARK_GRAY, "黑体", 12, Font.BOLD);
            PdfPCell cell_data = new PdfPCell(HeaderAndFooterEvent.AddParagraph(key, 0, 1.5f));
            cell_data.setVerticalAlignment(PdfPCell.ALIGN_MIDDLE);  //垂直居中
            cell_data.setHorizontalAlignment(PdfPCell.ALIGN_LEFT);//水平居中
            table.addCell(cell_data);

            cell_data = new PdfPCell(HeaderAndFooterEvent.AddParagraph(value, 0, 1.5f));
            cell_data.setVerticalAlignment(PdfPCell.ALIGN_MIDDLE);  //垂直居中
            cell_data.setHorizontalAlignment(PdfPCell.ALIGN_LEFT);//水平居中
            table.addCell(cell_data);
        }
        return table;
    }

    public PdfPTable setPdfPTableHead(PdfPTable table,List<String> list){
        for (int i = 0; i < list.size(); i++) {
            HeaderAndFooterEvent.SetFont(BaseColor.BLACK, "黑体", 12, Font.NORMAL);
            PdfPCell cell_data1 = new PdfPCell(HeaderAndFooterEvent.AddParagraph(list.get(i), 0, 1.5f));
            cell_data1.setVerticalAlignment(PdfPCell.ALIGN_MIDDLE);  //垂直居中
            cell_data1.setHorizontalAlignment(PdfPCell.ALIGN_LEFT);//水平居中
            table.addCell(cell_data1);
        }
        return table;
    }


}
