package com.sztzjy.fund_investment.controller;

import com.sztzjy.fund_investment.annotation.AnonymousAccess;
import com.sztzjy.fund_investment.entity.EduProjectValuation;
import com.sztzjy.fund_investment.service.ISysProjectValuationService;
import com.sztzjy.fund_investment.util.ResultEntity;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

//yz
@RestController
@RequestMapping("/projectValuationController")
@Api(tags = "学生端--项目估值")
public class ProjectValuation {
    @Autowired
    ISysProjectValuationService projectValuationService;

    @GetMapping("getPE")
    @ApiOperation("相对估值法-PE市盈率法")
    @AnonymousAccess
    public ResultEntity<List<EduProjectValuation>> getPE(@ApiParam("流程ID") @RequestParam String flowId) {
        List<EduProjectValuation> projectValuationList=projectValuationService.getPE(flowId);
        return new ResultEntity(HttpStatus.OK, "相对估值法-PE市盈率法，展示成功", projectValuationList);
    }

    @GetMapping("getPB")
    @ApiOperation("相对估值法-PE市盈率法")
    @AnonymousAccess
    public ResultEntity<List<EduProjectValuation>> getPB(@ApiParam("流程ID") @RequestParam String flowId) {
        List<EduProjectValuation> projectValuationList=projectValuationService.getPB(flowId);
        return new ResultEntity(HttpStatus.OK, "相对估值法-PB市盈率法，展示成功", projectValuationList);
    }

    @GetMapping("getPS")
    @ApiOperation("相对估值法-PE市盈率法")
    @AnonymousAccess
    public ResultEntity<List<EduProjectValuation>> getPS(@ApiParam("流程ID") @RequestParam String flowId) {
        List<EduProjectValuation> projectValuationList=projectValuationService.getPS(flowId);
        return new ResultEntity(HttpStatus.OK, "相对估值法-PS市盈率法，展示成功", projectValuationList);
    }

}
