package com.sztzjy.fund_investment.entity;

import java.math.BigDecimal;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 *
 * @author xcj
 * issuance_info
 */
public class IssuanceInfo {
    private String id;

    @ApiModelProperty("流程ID")
    private String flowId;

    @ApiModelProperty("公司名称")
    private String companyName;

    @ApiModelProperty("证券代码")
    private String securityCode;

    @ApiModelProperty("最低非限售A股市值")
    private BigDecimal minimumNonRestrictedASharesMarketValue;

    @ApiModelProperty("初步询价起始日期")
    private Date initialInquiryStartDate;

    @ApiModelProperty("网下申购起始日期")
    private Date offlineSubscriptionStartDate;

    @ApiModelProperty("发行总量(万股)")
    private BigDecimal totalIssuanceVolume;

    @ApiModelProperty("最低申购量(万股)")
    private BigDecimal minimumSubscriptionVolume;

    @ApiModelProperty("申购量变动最小单位(万股)")
    private BigDecimal minimumSubscriptionVolumeChangeUnit;

    @ApiModelProperty("初步询价最高申报价格与最低申报价格的最大比值（百分比）")
    private BigDecimal maximumPriceToMinimumPriceRatio;

    @ApiModelProperty("主承销商市盈率估值区间下限")
    private BigDecimal leadUnderwriterPeRatioValuationLowerLimit;

    @ApiModelProperty("是否已在结算公司开立结算备付金账户")
    private Byte settlementReserveAccountOpened;

    @ApiModelProperty("余股登记账户(深市)")
    private String remainingShareRegistrationAccountShenzhen;

    @ApiModelProperty("联合承销商")
    private String jointUnderwriters;

    @ApiModelProperty("证券简称")
    private String securityAbbreviation;

    @ApiModelProperty("定价方式")
    private String pricingMethod;

    @ApiModelProperty("是否设自愿锁定期")
    private Byte voluntaryLockupPeriod;

    @ApiModelProperty("初步询价截止日期")
    private Date initialInquiryDeadline;

    @ApiModelProperty("网下申购截止日期")
    private Date offlineSubscriptionDeadline;

    @ApiModelProperty("网下发行数量(万股)")
    private BigDecimal offlineIssuanceQuantity;

    @ApiModelProperty("最高由购量(万股)")
    private BigDecimal maximumSubscriptionQuantity;

    @ApiModelProperty("初步询价阶段的价格档位数量")
    private Integer numberOfPriceLevelsInInitialInquiryStage;

    @ApiModelProperty("主承销商市盈率估值区间上限")
    private BigDecimal leadUnderwriterPeRatioValuationUpperLimit;

    @ApiModelProperty("备付金账户")
    private String reserveAccount;

    @ApiModelProperty("余股托管席位(深市)")
    private String remainingShareCustodianSeatShenzhen;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id == null ? null : id.trim();
    }

    public String getFlowId() {
        return flowId;
    }

    public void setFlowId(String flowId) {
        this.flowId = flowId == null ? null : flowId.trim();
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName == null ? null : companyName.trim();
    }

    public String getSecurityCode() {
        return securityCode;
    }

    public void setSecurityCode(String securityCode) {
        this.securityCode = securityCode == null ? null : securityCode.trim();
    }

    public BigDecimal getMinimumNonRestrictedASharesMarketValue() {
        return minimumNonRestrictedASharesMarketValue;
    }

    public void setMinimumNonRestrictedASharesMarketValue(BigDecimal minimumNonRestrictedASharesMarketValue) {
        this.minimumNonRestrictedASharesMarketValue = minimumNonRestrictedASharesMarketValue;
    }

    public Date getInitialInquiryStartDate() {
        return initialInquiryStartDate;
    }

    public void setInitialInquiryStartDate(Date initialInquiryStartDate) {
        this.initialInquiryStartDate = initialInquiryStartDate;
    }

    public Date getOfflineSubscriptionStartDate() {
        return offlineSubscriptionStartDate;
    }

    public void setOfflineSubscriptionStartDate(Date offlineSubscriptionStartDate) {
        this.offlineSubscriptionStartDate = offlineSubscriptionStartDate;
    }

    public BigDecimal getTotalIssuanceVolume() {
        return totalIssuanceVolume;
    }

    public void setTotalIssuanceVolume(BigDecimal totalIssuanceVolume) {
        this.totalIssuanceVolume = totalIssuanceVolume;
    }

    public BigDecimal getMinimumSubscriptionVolume() {
        return minimumSubscriptionVolume;
    }

    public void setMinimumSubscriptionVolume(BigDecimal minimumSubscriptionVolume) {
        this.minimumSubscriptionVolume = minimumSubscriptionVolume;
    }

    public BigDecimal getMinimumSubscriptionVolumeChangeUnit() {
        return minimumSubscriptionVolumeChangeUnit;
    }

    public void setMinimumSubscriptionVolumeChangeUnit(BigDecimal minimumSubscriptionVolumeChangeUnit) {
        this.minimumSubscriptionVolumeChangeUnit = minimumSubscriptionVolumeChangeUnit;
    }

    public BigDecimal getMaximumPriceToMinimumPriceRatio() {
        return maximumPriceToMinimumPriceRatio;
    }

    public void setMaximumPriceToMinimumPriceRatio(BigDecimal maximumPriceToMinimumPriceRatio) {
        this.maximumPriceToMinimumPriceRatio = maximumPriceToMinimumPriceRatio;
    }

    public BigDecimal getLeadUnderwriterPeRatioValuationLowerLimit() {
        return leadUnderwriterPeRatioValuationLowerLimit;
    }

    public void setLeadUnderwriterPeRatioValuationLowerLimit(BigDecimal leadUnderwriterPeRatioValuationLowerLimit) {
        this.leadUnderwriterPeRatioValuationLowerLimit = leadUnderwriterPeRatioValuationLowerLimit;
    }

    public Byte getSettlementReserveAccountOpened() {
        return settlementReserveAccountOpened;
    }

    public void setSettlementReserveAccountOpened(Byte settlementReserveAccountOpened) {
        this.settlementReserveAccountOpened = settlementReserveAccountOpened;
    }

    public String getRemainingShareRegistrationAccountShenzhen() {
        return remainingShareRegistrationAccountShenzhen;
    }

    public void setRemainingShareRegistrationAccountShenzhen(String remainingShareRegistrationAccountShenzhen) {
        this.remainingShareRegistrationAccountShenzhen = remainingShareRegistrationAccountShenzhen == null ? null : remainingShareRegistrationAccountShenzhen.trim();
    }

    public String getJointUnderwriters() {
        return jointUnderwriters;
    }

    public void setJointUnderwriters(String jointUnderwriters) {
        this.jointUnderwriters = jointUnderwriters == null ? null : jointUnderwriters.trim();
    }

    public String getSecurityAbbreviation() {
        return securityAbbreviation;
    }

    public void setSecurityAbbreviation(String securityAbbreviation) {
        this.securityAbbreviation = securityAbbreviation == null ? null : securityAbbreviation.trim();
    }

    public String getPricingMethod() {
        return pricingMethod;
    }

    public void setPricingMethod(String pricingMethod) {
        this.pricingMethod = pricingMethod == null ? null : pricingMethod.trim();
    }

    public Byte getVoluntaryLockupPeriod() {
        return voluntaryLockupPeriod;
    }

    public void setVoluntaryLockupPeriod(Byte voluntaryLockupPeriod) {
        this.voluntaryLockupPeriod = voluntaryLockupPeriod;
    }

    public Date getInitialInquiryDeadline() {
        return initialInquiryDeadline;
    }

    public void setInitialInquiryDeadline(Date initialInquiryDeadline) {
        this.initialInquiryDeadline = initialInquiryDeadline;
    }

    public Date getOfflineSubscriptionDeadline() {
        return offlineSubscriptionDeadline;
    }

    public void setOfflineSubscriptionDeadline(Date offlineSubscriptionDeadline) {
        this.offlineSubscriptionDeadline = offlineSubscriptionDeadline;
    }

    public BigDecimal getOfflineIssuanceQuantity() {
        return offlineIssuanceQuantity;
    }

    public void setOfflineIssuanceQuantity(BigDecimal offlineIssuanceQuantity) {
        this.offlineIssuanceQuantity = offlineIssuanceQuantity;
    }

    public BigDecimal getMaximumSubscriptionQuantity() {
        return maximumSubscriptionQuantity;
    }

    public void setMaximumSubscriptionQuantity(BigDecimal maximumSubscriptionQuantity) {
        this.maximumSubscriptionQuantity = maximumSubscriptionQuantity;
    }

    public Integer getNumberOfPriceLevelsInInitialInquiryStage() {
        return numberOfPriceLevelsInInitialInquiryStage;
    }

    public void setNumberOfPriceLevelsInInitialInquiryStage(Integer numberOfPriceLevelsInInitialInquiryStage) {
        this.numberOfPriceLevelsInInitialInquiryStage = numberOfPriceLevelsInInitialInquiryStage;
    }

    public BigDecimal getLeadUnderwriterPeRatioValuationUpperLimit() {
        return leadUnderwriterPeRatioValuationUpperLimit;
    }

    public void setLeadUnderwriterPeRatioValuationUpperLimit(BigDecimal leadUnderwriterPeRatioValuationUpperLimit) {
        this.leadUnderwriterPeRatioValuationUpperLimit = leadUnderwriterPeRatioValuationUpperLimit;
    }

    public String getReserveAccount() {
        return reserveAccount;
    }

    public void setReserveAccount(String reserveAccount) {
        this.reserveAccount = reserveAccount == null ? null : reserveAccount.trim();
    }

    public String getRemainingShareCustodianSeatShenzhen() {
        return remainingShareCustodianSeatShenzhen;
    }

    public void setRemainingShareCustodianSeatShenzhen(String remainingShareCustodianSeatShenzhen) {
        this.remainingShareCustodianSeatShenzhen = remainingShareCustodianSeatShenzhen == null ? null : remainingShareCustodianSeatShenzhen.trim();
    }
}