package com.sztzjy.fund_investment.entity;

import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
/**
 *
 * @author xcj
 * issuance_parameter_input
 */
public class IssuanceParameterInput {
    private String id;

    @ApiModelProperty("流程ID")
    private String flowId;

    @ApiModelProperty("配售对象编码")
    private Integer allotmentObjectCode;

    @ApiModelProperty("公司名称")
    private String companyName;

    @ApiModelProperty("证券代码")
    private String securityCode;

    @ApiModelProperty("证券简称")
    private String securityAbbreviation;

    @ApiModelProperty("发行总量")
    private BigDecimal totalIssuanceVolume;

    @ApiModelProperty("发行价格")
    private BigDecimal issuancePrice;

    @ApiModelProperty("网下发行数量")
    private BigDecimal offlineIssuanceQuantity;

    @ApiModelProperty("每个配售对象申购数下限与入围数最之间的比值(%)")
    private BigDecimal minimumSubscriptionToShortlistedRatio;

    @ApiModelProperty("每个配售对象申购数上限与入围数最之间的比值(%)")
    private BigDecimal maximumSubscriptionToShortlistedRatio;

    @ApiModelProperty("摊薄前市盈率")
    private BigDecimal dilutedPeRatio;

    @ApiModelProperty("摊薄后市盈率")
    private BigDecimal undilutedPeRatio;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id == null ? null : id.trim();
    }

    public String getFlowId() {
        return flowId;
    }

    public void setFlowId(String flowId) {
        this.flowId = flowId == null ? null : flowId.trim();
    }

    public Integer getAllotmentObjectCode() {
        return allotmentObjectCode;
    }

    public void setAllotmentObjectCode(Integer allotmentObjectCode) {
        this.allotmentObjectCode = allotmentObjectCode;
    }

    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName == null ? null : companyName.trim();
    }

    public String getSecurityCode() {
        return securityCode;
    }

    public void setSecurityCode(String securityCode) {
        this.securityCode = securityCode == null ? null : securityCode.trim();
    }

    public String getSecurityAbbreviation() {
        return securityAbbreviation;
    }

    public void setSecurityAbbreviation(String securityAbbreviation) {
        this.securityAbbreviation = securityAbbreviation == null ? null : securityAbbreviation.trim();
    }

    public BigDecimal getTotalIssuanceVolume() {
        return totalIssuanceVolume;
    }

    public void setTotalIssuanceVolume(BigDecimal totalIssuanceVolume) {
        this.totalIssuanceVolume = totalIssuanceVolume;
    }

    public BigDecimal getIssuancePrice() {
        return issuancePrice;
    }

    public void setIssuancePrice(BigDecimal issuancePrice) {
        this.issuancePrice = issuancePrice;
    }

    public BigDecimal getOfflineIssuanceQuantity() {
        return offlineIssuanceQuantity;
    }

    public void setOfflineIssuanceQuantity(BigDecimal offlineIssuanceQuantity) {
        this.offlineIssuanceQuantity = offlineIssuanceQuantity;
    }

    public BigDecimal getMinimumSubscriptionToShortlistedRatio() {
        return minimumSubscriptionToShortlistedRatio;
    }

    public void setMinimumSubscriptionToShortlistedRatio(BigDecimal minimumSubscriptionToShortlistedRatio) {
        this.minimumSubscriptionToShortlistedRatio = minimumSubscriptionToShortlistedRatio;
    }

    public BigDecimal getMaximumSubscriptionToShortlistedRatio() {
        return maximumSubscriptionToShortlistedRatio;
    }

    public void setMaximumSubscriptionToShortlistedRatio(BigDecimal maximumSubscriptionToShortlistedRatio) {
        this.maximumSubscriptionToShortlistedRatio = maximumSubscriptionToShortlistedRatio;
    }

    public BigDecimal getDilutedPeRatio() {
        return dilutedPeRatio;
    }

    public void setDilutedPeRatio(BigDecimal dilutedPeRatio) {
        this.dilutedPeRatio = dilutedPeRatio;
    }

    public BigDecimal getUndilutedPeRatio() {
        return undilutedPeRatio;
    }

    public void setUndilutedPeRatio(BigDecimal undilutedPeRatio) {
        this.undilutedPeRatio = undilutedPeRatio;
    }
}