package com.sztzjy.fund_investment.entity;

import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.format.annotation.DateTimeFormat;

/**
 *
 * @author xcj
 * performance_score
 */
public class PerformanceScore {
    @ApiModelProperty("表ID")
    private String id;

    @ApiModelProperty("流程ID")
    private String flowId;

    @ApiModelProperty("学校ID")
    private String schoolId;

    @ApiModelProperty("班级ID")
    private String classId;

    @ApiModelProperty("实务认知得分")
    private BigDecimal practicalCognitionScore;

    @ApiModelProperty("知识测评得分")
    private BigDecimal knowledgeAssessmentScore;

    @ApiModelProperty("基金募资得分")
    private BigDecimal fundraisingScore;

    @ApiModelProperty("寻找项目/确定项目并立项得分")
    private BigDecimal projectSearchScore;

    @ApiModelProperty("寻找项目/评估结论得分")
    private BigDecimal projectSearchReportScore;

    @ApiModelProperty("项目尽调/测验得分")
    private BigDecimal projectDueDiligenceScore;

    @ApiModelProperty("项目尽调/评估风险得分")
    private BigDecimal projectValuationEstimationRiskScore;

    @ApiModelProperty("项目尽调/业务尽调结论得分")
    private BigDecimal projectDueDiligenceBusinessReportScore;

    @ApiModelProperty("项目尽调/财务尽调结论得分")
    private BigDecimal projectDueDiligenceFinanceReportScore;

    @ApiModelProperty("项目估值/相对估值结论得分")
    private BigDecimal projectValuationRelativeScore;

    @ApiModelProperty("项目估值/测验得分")
    private BigDecimal projectValuationScore;

    @ApiModelProperty("项目估值/绝对估值结论得分")
    private BigDecimal projectValuationAbsoluteScore;

    @ApiModelProperty("项目估值/计算绝对估值得分")
    private BigDecimal projectUseValuationAbsoluteScore;

    @ApiModelProperty("项目估值/计算相对估值得分")
    private BigDecimal projectUseValuationRelativeScore;

    @ApiModelProperty("签约投资/估值报告得分")
    private BigDecimal investmentSigningVlauationReportScore;

    @ApiModelProperty("签约投资/尽调报告得分")
    private BigDecimal investmentSigningDiligenceReportScore;

    @ApiModelProperty("签约投资/投资意向书得分")
    private BigDecimal investmentSigningInvestScore;

    @ApiModelProperty("签约投资/协议得分")
    private BigDecimal investmentSigningScore;

    @ApiModelProperty("IPO/弹窗1上市流程得分")
    private BigDecimal ipoFlowScore;

    @ApiModelProperty("IPO/弹窗2/上市板块得分")
    private BigDecimal ipoListedSectorScore;

    @ApiModelProperty("IPO/弹窗2/上市条件得分")
    private BigDecimal ipoListedConditionScore;

    @ApiModelProperty("询价发行/新建发行申请得分")
    private BigDecimal newPricingIssuanceScore;

    @ApiModelProperty("询价发行/询价投资者确定得分")
    private BigDecimal pricingIssuanceConfirmScore;

    @ApiModelProperty("询价发行/初步询价得分")
    private BigDecimal initPricingIssuanceScore;

    @ApiModelProperty("询价发行/询价结果及参数发行录入")
    private BigDecimal pricingIssuanceEnteringScore;

    @ApiModelProperty("收益管理/计算市值得分")
    private BigDecimal profitManagementMarketValueScore;

    @ApiModelProperty("收益管理/计算基金收益得分")
    private BigDecimal profitManagementFundScore;

    @ApiModelProperty("收益管理/退出时计算市值得分")
    private BigDecimal profitManagementFundExitScore;

    @ApiModelProperty("收益管理/退出时计算基金收益得分")
    private BigDecimal profitManagementMarketValueExitScore;

    @ApiModelProperty("收益分配得分")
    private BigDecimal profitDistributionScore;

    @ApiModelProperty("投资报告/提交报告得分")
    private BigDecimal investmentReportScore;

    @ApiModelProperty("投资报告/心得体会得分")
    private BigDecimal experienceScore;

    @ApiModelProperty("总成绩")
    private BigDecimal totalScore;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("实务认知完成时间")
    private Date practicalCognitionTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("知识测评完成时间")
    private Date knowledgeAssessmentTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("基金募资完成时间")
    private Date fundraisingTime;

    @ApiModelProperty("寻找项目完成时间")
    private Date projectSearchTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("项目尽调完成时间")
    private Date projectDueDiligenceTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("项目估值完成时间")
    private Date projectValuationTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("签约投资完成时间")
    private Date investmentSigningTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("ipo页面完成时间")
    private Date ipoTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("询价发行完成时间")
    private Date pricingIssuanceTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("收益管理完成时间")
    private Date profitManagementTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("收益分配完成时间")
    private Date profitDistributionTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @ApiModelProperty("投资报告页面完成时间")
    private Date investmentReportTime;

    public void set(String methodName, Object value) {
        try {
            Method method = getClass().getMethod("set" + Character.toUpperCase(methodName.charAt(0)) + methodName.substring(1),value.getClass());
            method.invoke(this, value);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public Object get(String methodName) {
        Object result = null;
        try {
            Method method = getClass().getMethod("get" + Character.toUpperCase(methodName.charAt(0)) + methodName.substring(1));
            result = method.invoke(this);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }



    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id == null ? null : id.trim();
    }

    public String getFlowId() {
        return flowId;
    }

    public void setFlowId(String flowId) {
        this.flowId = flowId == null ? null : flowId.trim();
    }

    public String getSchoolId() {
        return schoolId;
    }

    public void setSchoolId(String schoolId) {
        this.schoolId = schoolId == null ? null : schoolId.trim();
    }

    public String getClassId() {
        return classId;
    }

    public void setClassId(String classId) {
        this.classId = classId == null ? null : classId.trim();
    }

    public BigDecimal getPracticalCognitionScore() {
        return practicalCognitionScore;
    }

    public void setPracticalCognitionScore(BigDecimal practicalCognitionScore) {
        this.practicalCognitionScore = practicalCognitionScore;
    }

    public BigDecimal getKnowledgeAssessmentScore() {
        return knowledgeAssessmentScore;
    }

    public void setKnowledgeAssessmentScore(BigDecimal knowledgeAssessmentScore) {
        this.knowledgeAssessmentScore = knowledgeAssessmentScore;
    }

    public BigDecimal getFundraisingScore() {
        return fundraisingScore;
    }

    public void setFundraisingScore(BigDecimal fundraisingScore) {
        this.fundraisingScore = fundraisingScore;
    }

    public BigDecimal getProjectSearchScore() {
        return projectSearchScore;
    }

    public void setProjectSearchScore(BigDecimal projectSearchScore) {
        this.projectSearchScore = projectSearchScore;
    }

    public BigDecimal getProjectSearchReportScore() {
        return projectSearchReportScore;
    }

    public void setProjectSearchReportScore(BigDecimal projectSearchReportScore) {
        this.projectSearchReportScore = projectSearchReportScore;
    }

    public BigDecimal getProjectDueDiligenceScore() {
        return projectDueDiligenceScore;
    }

    public void setProjectDueDiligenceScore(BigDecimal projectDueDiligenceScore) {
        this.projectDueDiligenceScore = projectDueDiligenceScore;
    }

    public BigDecimal getProjectValuationEstimationRiskScore() {
        return projectValuationEstimationRiskScore;
    }

    public void setProjectValuationEstimationRiskScore(BigDecimal projectValuationEstimationRiskScore) {
        this.projectValuationEstimationRiskScore = projectValuationEstimationRiskScore;
    }

    public BigDecimal getProjectDueDiligenceBusinessReportScore() {
        return projectDueDiligenceBusinessReportScore;
    }

    public void setProjectDueDiligenceBusinessReportScore(BigDecimal projectDueDiligenceBusinessReportScore) {
        this.projectDueDiligenceBusinessReportScore = projectDueDiligenceBusinessReportScore;
    }

    public BigDecimal getProjectDueDiligenceFinanceReportScore() {
        return projectDueDiligenceFinanceReportScore;
    }

    public void setProjectDueDiligenceFinanceReportScore(BigDecimal projectDueDiligenceFinanceReportScore) {
        this.projectDueDiligenceFinanceReportScore = projectDueDiligenceFinanceReportScore;
    }

    public BigDecimal getProjectValuationRelativeScore() {
        return projectValuationRelativeScore;
    }

    public void setProjectValuationRelativeScore(BigDecimal projectValuationRelativeScore) {
        this.projectValuationRelativeScore = projectValuationRelativeScore;
    }

    public BigDecimal getProjectValuationScore() {
        return projectValuationScore;
    }

    public void setProjectValuationScore(BigDecimal projectValuationScore) {
        this.projectValuationScore = projectValuationScore;
    }

    public BigDecimal getProjectValuationAbsoluteScore() {
        return projectValuationAbsoluteScore;
    }

    public void setProjectValuationAbsoluteScore(BigDecimal projectValuationAbsoluteScore) {
        this.projectValuationAbsoluteScore = projectValuationAbsoluteScore;
    }

    public BigDecimal getProjectUseValuationAbsoluteScore() {
        return projectUseValuationAbsoluteScore;
    }

    public void setProjectUseValuationAbsoluteScore(BigDecimal projectUseValuationAbsoluteScore) {
        this.projectUseValuationAbsoluteScore = projectUseValuationAbsoluteScore;
    }

    public BigDecimal getProjectUseValuationRelativeScore() {
        return projectUseValuationRelativeScore;
    }

    public void setProjectUseValuationRelativeScore(BigDecimal projectUseValuationRelativeScore) {
        this.projectUseValuationRelativeScore = projectUseValuationRelativeScore;
    }

    public BigDecimal getInvestmentSigningVlauationReportScore() {
        return investmentSigningVlauationReportScore;
    }

    public void setInvestmentSigningVlauationReportScore(BigDecimal investmentSigningVlauationReportScore) {
        this.investmentSigningVlauationReportScore = investmentSigningVlauationReportScore;
    }

    public BigDecimal getInvestmentSigningDiligenceReportScore() {
        return investmentSigningDiligenceReportScore;
    }

    public void setInvestmentSigningDiligenceReportScore(BigDecimal investmentSigningDiligenceReportScore) {
        this.investmentSigningDiligenceReportScore = investmentSigningDiligenceReportScore;
    }

    public BigDecimal getInvestmentSigningInvestScore() {
        return investmentSigningInvestScore;
    }

    public void setInvestmentSigningInvestScore(BigDecimal investmentSigningInvestScore) {
        this.investmentSigningInvestScore = investmentSigningInvestScore;
    }

    public BigDecimal getInvestmentSigningScore() {
        return investmentSigningScore;
    }

    public void setInvestmentSigningScore(BigDecimal investmentSigningScore) {
        this.investmentSigningScore = investmentSigningScore;
    }

    public BigDecimal getIpoFlowScore() {
        return ipoFlowScore;
    }

    public void setIpoFlowScore(BigDecimal ipoFlowScore) {
        this.ipoFlowScore = ipoFlowScore;
    }

    public BigDecimal getIpoListedSectorScore() {
        return ipoListedSectorScore;
    }

    public void setIpoListedSectorScore(BigDecimal ipoListedSectorScore) {
        this.ipoListedSectorScore = ipoListedSectorScore;
    }

    public BigDecimal getIpoListedConditionScore() {
        return ipoListedConditionScore;
    }

    public void setIpoListedConditionScore(BigDecimal ipoListedConditionScore) {
        this.ipoListedConditionScore = ipoListedConditionScore;
    }

    public BigDecimal getNewPricingIssuanceScore() {
        return newPricingIssuanceScore;
    }

    public void setNewPricingIssuanceScore(BigDecimal newPricingIssuanceScore) {
        this.newPricingIssuanceScore = newPricingIssuanceScore;
    }

    public BigDecimal getPricingIssuanceConfirmScore() {
        return pricingIssuanceConfirmScore;
    }

    public void setPricingIssuanceConfirmScore(BigDecimal pricingIssuanceConfirmScore) {
        this.pricingIssuanceConfirmScore = pricingIssuanceConfirmScore;
    }

    public BigDecimal getInitPricingIssuanceScore() {
        return initPricingIssuanceScore;
    }

    public void setInitPricingIssuanceScore(BigDecimal initPricingIssuanceScore) {
        this.initPricingIssuanceScore = initPricingIssuanceScore;
    }

    public BigDecimal getPricingIssuanceEnteringScore() {
        return pricingIssuanceEnteringScore;
    }

    public void setPricingIssuanceEnteringScore(BigDecimal pricingIssuanceEnteringScore) {
        this.pricingIssuanceEnteringScore = pricingIssuanceEnteringScore;
    }

    public BigDecimal getProfitManagementMarketValueScore() {
        return profitManagementMarketValueScore;
    }

    public void setProfitManagementMarketValueScore(BigDecimal profitManagementMarketValueScore) {
        this.profitManagementMarketValueScore = profitManagementMarketValueScore;
    }

    public BigDecimal getProfitManagementFundScore() {
        return profitManagementFundScore;
    }

    public void setProfitManagementFundScore(BigDecimal profitManagementFundScore) {
        this.profitManagementFundScore = profitManagementFundScore;
    }

    public BigDecimal getProfitManagementFundExitScore() {
        return profitManagementFundExitScore;
    }

    public void setProfitManagementFundExitScore(BigDecimal profitManagementFundExitScore) {
        this.profitManagementFundExitScore = profitManagementFundExitScore;
    }

    public BigDecimal getProfitManagementMarketValueExitScore() {
        return profitManagementMarketValueExitScore;
    }

    public void setProfitManagementMarketValueExitScore(BigDecimal profitManagementMarketValueExitScore) {
        this.profitManagementMarketValueExitScore = profitManagementMarketValueExitScore;
    }

    public BigDecimal getProfitDistributionScore() {
        return profitDistributionScore;
    }

    public void setProfitDistributionScore(BigDecimal profitDistributionScore) {
        this.profitDistributionScore = profitDistributionScore;
    }

    public BigDecimal getInvestmentReportScore() {
        return investmentReportScore;
    }

    public void setInvestmentReportScore(BigDecimal investmentReportScore) {
        this.investmentReportScore = investmentReportScore;
    }

    public BigDecimal getExperienceScore() {
        return experienceScore;
    }

    public void setExperienceScore(BigDecimal experienceScore) {
        this.experienceScore = experienceScore;
    }

    public BigDecimal getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(BigDecimal totalScore) {
        this.totalScore = totalScore;
    }

    public Date getPracticalCognitionTime() {
        return practicalCognitionTime;
    }

    public void setPracticalCognitionTime(Date practicalCognitionTime) {
        this.practicalCognitionTime = practicalCognitionTime;
    }

    public Date getKnowledgeAssessmentTime() {
        return knowledgeAssessmentTime;
    }

    public void setKnowledgeAssessmentTime(Date knowledgeAssessmentTime) {
        this.knowledgeAssessmentTime = knowledgeAssessmentTime;
    }

    public Date getFundraisingTime() {
        return fundraisingTime;
    }

    public void setFundraisingTime(Date fundraisingTime) {
        this.fundraisingTime = fundraisingTime;
    }

    public Date getProjectSearchTime() {
        return projectSearchTime;
    }

    public void setProjectSearchTime(Date projectSearchTime) {
        this.projectSearchTime = projectSearchTime;
    }

    public Date getProjectDueDiligenceTime() {
        return projectDueDiligenceTime;
    }

    public void setProjectDueDiligenceTime(Date projectDueDiligenceTime) {
        this.projectDueDiligenceTime = projectDueDiligenceTime;
    }

    public Date getProjectValuationTime() {
        return projectValuationTime;
    }

    public void setProjectValuationTime(Date projectValuationTime) {
        this.projectValuationTime = projectValuationTime;
    }

    public Date getInvestmentSigningTime() {
        return investmentSigningTime;
    }

    public void setInvestmentSigningTime(Date investmentSigningTime) {
        this.investmentSigningTime = investmentSigningTime;
    }

    public Date getIpoTime() {
        return ipoTime;
    }

    public void setIpoTime(Date ipoTime) {
        this.ipoTime = ipoTime;
    }

    public Date getPricingIssuanceTime() {
        return pricingIssuanceTime;
    }

    public void setPricingIssuanceTime(Date pricingIssuanceTime) {
        this.pricingIssuanceTime = pricingIssuanceTime;
    }

    public Date getProfitManagementTime() {
        return profitManagementTime;
    }

    public void setProfitManagementTime(Date profitManagementTime) {
        this.profitManagementTime = profitManagementTime;
    }

    public Date getProfitDistributionTime() {
        return profitDistributionTime;
    }

    public void setProfitDistributionTime(Date profitDistributionTime) {
        this.profitDistributionTime = profitDistributionTime;
    }

    public Date getInvestmentReportTime() {
        return investmentReportTime;
    }

    public void setInvestmentReportTime(Date investmentReportTime) {
        this.investmentReportTime = investmentReportTime;
    }
}