package com.sztzjy.fund_investment.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @author xcj
 * performance_score
 */
public class PerformanceScoreDto {
    @ApiModelProperty("表ID")
    private String id;

    @ApiModelProperty("流程ID")
    private String flowId;

    @ApiModelProperty("实务认知学习进度")
    private String practicalCognitionSchedule;

    @ApiModelProperty("知识测评进度")
    private String knowledgeAssessmentSchedule;

    @ApiModelProperty("基金募资进度")
    private String fundraisingSchedule;

    @ApiModelProperty("寻找项目进度")
    private String projectSearchSchedule;

    @ApiModelProperty("项目尽调进度")
    private String projectDueDiligenceSchedule;

    @ApiModelProperty("项目估值进度")
    private String projectValuationSchedule;

    @ApiModelProperty("签约投资进度")
    private String investmentSigningSchedule;

    @ApiModelProperty("IPO申请进度")
    private String ipoSchedule;

    @ApiModelProperty("询价发行进度")
    private String pricingIssuanceSchedule;

    @ApiModelProperty("收益管理进度")
    private String profitManagementSchedule;

    @ApiModelProperty("收益分配进度")
    private String profitDistributionSchedule;

    @ApiModelProperty("投资报告进度")
    private String investmentReportSchedule;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("实务认知完成时间")
    private Date practicalCognitionTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("知识测评完成时间")
    private Date knowledgeAssessmentTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("基金募资完成时间")
    private Date fundraisingTime;

    @ApiModelProperty("寻找项目完成时间")
    private Date projectSearchTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("项目尽调完成时间")
    private Date projectDueDiligenceTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("项目估值完成时间")
    private Date projectValuationTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("签约投资完成时间")
    private Date investmentSigningTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("ipo页面完成时间")
    private Date ipoTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("询价发行完成时间")
    private Date pricingIssuanceTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("收益管理完成时间")
    private Date profitManagementTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("收益分配完成时间")
    private Date profitDistributionTime;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty("投资报告页面完成时间")
    private Date investmentReportTime;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFlowId() {
        return flowId;
    }

    public void setFlowId(String flowId) {
        this.flowId = flowId;
    }

    public String getPracticalCognitionSchedule() {
        return practicalCognitionSchedule;
    }

    public void setPracticalCognitionSchedule(String practicalCognitionSchedule) {
        this.practicalCognitionSchedule = practicalCognitionSchedule;
    }

    public String getKnowledgeAssessmentSchedule() {
        return knowledgeAssessmentSchedule;
    }

    public void setKnowledgeAssessmentSchedule(String knowledgeAssessmentSchedule) {
        this.knowledgeAssessmentSchedule = knowledgeAssessmentSchedule;
    }

    public String getFundraisingSchedule() {
        return fundraisingSchedule;
    }

    public void setFundraisingSchedule(String fundraisingSchedule) {
        this.fundraisingSchedule = fundraisingSchedule;
    }

    public String getProjectSearchSchedule() {
        return projectSearchSchedule;
    }

    public void setProjectSearchSchedule(String projectSearchSchedule) {
        this.projectSearchSchedule = projectSearchSchedule;
    }

    public String getProjectDueDiligenceSchedule() {
        return projectDueDiligenceSchedule;
    }

    public void setProjectDueDiligenceSchedule(String projectDueDiligenceSchedule) {
        this.projectDueDiligenceSchedule = projectDueDiligenceSchedule;
    }

    public String getProjectValuationSchedule() {
        return projectValuationSchedule;
    }

    public void setProjectValuationSchedule(String projectValuationSchedule) {
        this.projectValuationSchedule = projectValuationSchedule;
    }

    public String getInvestmentSigningSchedule() {
        return investmentSigningSchedule;
    }

    public void setInvestmentSigningSchedule(String investmentSigningSchedule) {
        this.investmentSigningSchedule = investmentSigningSchedule;
    }

    public String getIpoSchedule() {
        return ipoSchedule;
    }

    public void setIpoSchedule(String ipoSchedule) {
        this.ipoSchedule = ipoSchedule;
    }

    public String getPricingIssuanceSchedule() {
        return pricingIssuanceSchedule;
    }

    public void setPricingIssuanceSchedule(String pricingIssuanceSchedule) {
        this.pricingIssuanceSchedule = pricingIssuanceSchedule;
    }

    public String getProfitManagementSchedule() {
        return profitManagementSchedule;
    }

    public void setProfitManagementSchedule(String profitManagementSchedule) {
        this.profitManagementSchedule = profitManagementSchedule;
    }

    public String getProfitDistributionSchedule() {
        return profitDistributionSchedule;
    }

    public void setProfitDistributionSchedule(String profitDistributionSchedule) {
        this.profitDistributionSchedule = profitDistributionSchedule;
    }

    public String getInvestmentReportSchedule() {
        return investmentReportSchedule;
    }

    public void setInvestmentReportSchedule(String investmentReportSchedule) {
        this.investmentReportSchedule = investmentReportSchedule;
    }

    public Date getPracticalCognitionTime() {
        return practicalCognitionTime;
    }

    public void setPracticalCognitionTime(Date practicalCognitionTime) {
        this.practicalCognitionTime = practicalCognitionTime;
    }

    public Date getKnowledgeAssessmentTime() {
        return knowledgeAssessmentTime;
    }

    public void setKnowledgeAssessmentTime(Date knowledgeAssessmentTime) {
        this.knowledgeAssessmentTime = knowledgeAssessmentTime;
    }

    public Date getFundraisingTime() {
        return fundraisingTime;
    }

    public void setFundraisingTime(Date fundraisingTime) {
        this.fundraisingTime = fundraisingTime;
    }

    public Date getProjectSearchTime() {
        return projectSearchTime;
    }

    public void setProjectSearchTime(Date projectSearchTime) {
        this.projectSearchTime = projectSearchTime;
    }

    public Date getProjectDueDiligenceTime() {
        return projectDueDiligenceTime;
    }

    public void setProjectDueDiligenceTime(Date projectDueDiligenceTime) {
        this.projectDueDiligenceTime = projectDueDiligenceTime;
    }

    public Date getProjectValuationTime() {
        return projectValuationTime;
    }

    public void setProjectValuationTime(Date projectValuationTime) {
        this.projectValuationTime = projectValuationTime;
    }

    public Date getInvestmentSigningTime() {
        return investmentSigningTime;
    }

    public void setInvestmentSigningTime(Date investmentSigningTime) {
        this.investmentSigningTime = investmentSigningTime;
    }

    public Date getIpoTime() {
        return ipoTime;
    }

    public void setIpoTime(Date ipoTime) {
        this.ipoTime = ipoTime;
    }

    public Date getPricingIssuanceTime() {
        return pricingIssuanceTime;
    }

    public void setPricingIssuanceTime(Date pricingIssuanceTime) {
        this.pricingIssuanceTime = pricingIssuanceTime;
    }

    public Date getProfitManagementTime() {
        return profitManagementTime;
    }

    public void setProfitManagementTime(Date profitManagementTime) {
        this.profitManagementTime = profitManagementTime;
    }

    public Date getProfitDistributionTime() {
        return profitDistributionTime;
    }

    public void setProfitDistributionTime(Date profitDistributionTime) {
        this.profitDistributionTime = profitDistributionTime;
    }

    public Date getInvestmentReportTime() {
        return investmentReportTime;
    }

    public void setInvestmentReportTime(Date investmentReportTime) {
        this.investmentReportTime = investmentReportTime;
    }
}