package com.sztzjy.fund_investment.entity.treeSelect;



import com.sztzjy.fund_investment.entity.ProFinancialIndex;
import com.sztzjy.fund_investment.entity.ProFinancialStatement;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class TreeSelect implements Serializable {
    private static final long serialVersionUID = 1L;
    /** 节点ID */
    private String id;

    /** 节点名称 */
    private String name;

    private String parentId;

    /** 子节点 */
    private List<TreeSelect> children;

    public TreeSelect(ProFinancialIndex financialIndex) {
        this.id=financialIndex.getId();
        this.name=financialIndex.getName();
        this.parentId=financialIndex.getParentId();
    }

    public TreeSelect(ProFinancialStatement financialStatement) {
        this.id=financialStatement.getId();
        this.name=financialStatement.getName();
        this.parentId=financialStatement.getParentId();
    }

    public static List<TreeSelect> buildTree(List<TreeSelect> dataList) {
        List<TreeSelect> treeList = new ArrayList<>();

        for (TreeSelect data : dataList) {
            if ("0".equals(data.parentId)) {
                treeList.add(findChildren(data, dataList));
            }
        }

        return treeList;
    }

    private static TreeSelect findChildren(TreeSelect parent, List<TreeSelect> dataList) {
        for (TreeSelect data : dataList) {
            if (parent.id.equals(data.parentId)) {
                if (parent.children == null) {
                    parent.children = new ArrayList<>();
                }
                parent.children.add(findChildren(data, dataList));
            }
        }

        return parent;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public List<TreeSelect> getChildren() {
        return children;
    }

    public void setChildren(List<TreeSelect> children) {
        this.children = children;
    }
}
