package com.sztzjy.fund_investment.service.serviceImpl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sztzjy.fund_investment.entity.AllotmentObject;
import com.sztzjy.fund_investment.entity.AllotmentObjectExample;
import com.sztzjy.fund_investment.entity.dto.AllotmentObjectDTO;
import com.sztzjy.fund_investment.mapper.AllotmentObjectMapper;
import com.sztzjy.fund_investment.service.InquiryIssuanceService;
import com.sztzjy.fund_investment.util.ConvertUtil;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * @author tz
 * @date 2023/12/5 8:58
 */
@Service
public class InquiryIssuanceServiceImpl implements InquiryIssuanceService {
    @Resource
    AllotmentObjectMapper allotmentObjectMapper;
    @Resource
    ConvertUtil convertUtil;
    @Override
    public PageInfo<AllotmentObjectDTO> queryInquiryInvestors(String flowId, Integer size, Integer index) {
        //开启分页
        PageHelper.startPage(size,index);
        AllotmentObjectExample allotmentObjectExample=new AllotmentObjectExample();
        allotmentObjectExample.createCriteria().andFlowIdEqualTo(flowId);
        List<AllotmentObject> allotmentObjects = allotmentObjectMapper.selectByExample(allotmentObjectExample);
        List<AllotmentObjectDTO> allotmentObjectDTOS =new ArrayList<>();
        if(allotmentObjects.isEmpty()){
            AllotmentObjectExample allotmentObjectExample1=new AllotmentObjectExample();
            allotmentObjectExample1.createCriteria().andFlowIdIsNull();
            List<AllotmentObject> list = allotmentObjectMapper.selectByExample(allotmentObjectExample1);
            if(list.size()>0){
                for (int i = 0; i < list.size(); i++) {
                    list.get(i).setId(String.valueOf(UUID.randomUUID()));
                    list.get(i).setLogic(1);
                    list.get(i).setFlowId(flowId);
                    allotmentObjectMapper.insert(list.get(i));
                    AllotmentObjectDTO allotmentObjectDTO = convertUtil.entityToDTO(list.get(i), AllotmentObjectDTO.class);
                    allotmentObjectDTO.setSure("是");
                    allotmentObjectDTOS.add(allotmentObjectDTO);
                }
            }
            PageInfo<AllotmentObjectDTO> pageInfo=new PageInfo<>(allotmentObjectDTOS);
            return pageInfo;
        }
        for (int i = 0; i < allotmentObjects.size(); i++) {
            AllotmentObjectDTO allotmentObjectDTO = convertUtil.entityToDTO(allotmentObjects.get(i), AllotmentObjectDTO.class);
            if(allotmentObjects.get(i).getLogic()==1){
                allotmentObjectDTO.setSure("是");
                allotmentObjectDTOS.add(allotmentObjectDTO);
            }
            if(allotmentObjects.get(i).getLogic()==0){
                allotmentObjectDTO.setSure("否");
                allotmentObjectDTOS.add(allotmentObjectDTO);
            }
        }
        PageInfo<AllotmentObjectDTO> pageInfo=new PageInfo<>(allotmentObjectDTOS);
        return pageInfo;
    }

//    @Override
//    public List<AllotmentObject> queryBuiltIn(String flowId) {
//        AllotmentObjectExample allotmentObjectExample=new AllotmentObjectExample();
//        allotmentObjectExample.createCriteria().andFlowIdEqualTo(flowId);
//        List<AllotmentObject> allotmentObjects = allotmentObjectMapper.selectByExample(allotmentObjectExample);
//        if (allotmentObjects.isEmpty()){ //判断是否有已操作过的数据 没有则展示默认数据
//            allotmentObjectExample.createCriteria().andFlowIdIsNull();
//            List<AllotmentObject> allotmentObjects1 = allotmentObjectMapper.selectByExample(allotmentObjectExample);
//            return allotmentObjects1;
//        }
//        //有则配售对象编码在最近一次新增的基础上自增
//        allotmentObjectExample.setOrderByClause("create_time desc");
//        List<AllotmentObject> allotmentObjects1 = allotmentObjectMapper.selectByExample(allotmentObjectExample);
//        if(allotmentObjects1.size()>0){
//            AllotmentObject allotmentObject = allotmentObjects1.get(0);
//            List<AllotmentObject> list=new ArrayList<>();
//            //取到配售对象编码
//            String allotmentObjectCode = allotmentObject.getAllotmentObjectCode();
//            String substring = allotmentObjectCode.substring(1); //取到第二位
//            String s = substring.replaceAll("^(0+)", ""); //从第一个不为0的开始截取
//            Integer i = Integer.valueOf(s);
//            i++; //第一个配售对象编码自增
//            String number = String.format("I" + "%09d", i);
//            allotmentObject.setAllotmentObjectCode(number);
//            list.add(allotmentObject);
//            i++; //第二个配售对象编码自增
//            String number1 = String.format("I" + "%09d", i);
//            allotmentObject.setAllotmentObjectCode(number1);
//            list.add(allotmentObject);
//            return list;
//        }
//        return null;
//    }

    @Override
    public void insertInquiryInvestors(String[] ids,String flowId) {
        for (int i = 0; i < ids.length; i++) {
            AllotmentObject allotmentObject = allotmentObjectMapper.selectByPrimaryKey(ids[i]);
            allotmentObject.setLogic(1);
            allotmentObjectMapper.updateByPrimaryKey(allotmentObject);
        }
    }

    @Override
    public void deleteInquiryInvestors(String[] ids, String flowId) {
        for (int i = 0; i < ids.length; i++) {
            AllotmentObject allotmentObject = allotmentObjectMapper.selectByPrimaryKey(ids[i]);
            allotmentObject.setLogic(0);
            allotmentObjectMapper.updateByPrimaryKey(allotmentObject);
        }
    }
}
