package com.sztzjy.fund_investment.service.serviceImpl;

import com.sztzjy.fund_investment.entity.PerformanceScore;
import com.sztzjy.fund_investment.entity.PerformanceScoreExample;
import com.sztzjy.fund_investment.mapper.PerformanceScoreMapper;
import com.sztzjy.fund_investment.service.PerformanceScoreService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;

/**
 * @Author xcj
 * @Date 2023/11/15
 */
@Service
public class PerformanceScoreServiceImpl implements PerformanceScoreService {
    @Autowired
    private PerformanceScoreMapper performanceScoreMapper;


    /* 计分方法
     * @author xcj
     * @Date 2023/11/15
     */
    @Override     //                          实体类字段名          分数           流程ID
    public void calculateScoreByModule(String methodName, Integer score, String flowId) {
        PerformanceScoreExample performanceScoreExample = new PerformanceScoreExample();
        performanceScoreExample.createCriteria().andFlowIdEqualTo(flowId);
        List<PerformanceScore> performanceScores = performanceScoreMapper.selectByExample(performanceScoreExample);
        PerformanceScore performanceScore = performanceScores.get(0);

        BigDecimal scoreOld =(BigDecimal) performanceScore.get(methodName);
        performanceScore.set(methodName, BigDecimal.valueOf(score));
        performanceScore.setTotalScore(performanceScore.getTotalScore().add(BigDecimal.valueOf(score).subtract(scoreOld)));
        performanceScoreMapper.updateByPrimaryKey(performanceScore);
    }

    @Override
    public PerformanceScore getByFlowId(String flowId) {
        PerformanceScoreExample performanceScoreExample = new PerformanceScoreExample();
        performanceScoreExample.createCriteria().andFlowIdEqualTo(flowId);
        List<PerformanceScore> performanceScores = performanceScoreMapper.selectByExample(performanceScoreExample);
        return performanceScores.get(0);
    }


}
