package com.sztzjy.fund_investment.service.serviceImpl;

import cn.hutool.core.util.IdUtil;
import com.sztzjy.fund_investment.config.Constant;
import com.sztzjy.fund_investment.entity.ProfitManagement;
import com.sztzjy.fund_investment.entity.ProfitManagementExample;
import com.sztzjy.fund_investment.mapper.ProfitManagementMapper;
import com.sztzjy.fund_investment.service.ProfitManagementService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

/**
 * @Author xcj
 * @Date 2023/11/23
 */
@Service
public class ProfitManagementServiceImpl implements ProfitManagementService {
    @Autowired
    private ProfitManagementMapper profitManagementMapper;


    /*
     * @author xcj
     * @Date 2023/11/23
     */
    @Override
    public List<ProfitManagement> getLineChart(String flowId) {
        ProfitManagementExample profitManagementExample = new ProfitManagementExample();
        profitManagementExample.createCriteria().andFlowIdEqualTo(flowId);
        profitManagementExample.setOrderByClause("market_time ASC");
        List<ProfitManagement> profitManagementList = profitManagementMapper.selectByExample(profitManagementExample);
        if (!profitManagementList.isEmpty()) {
            return profitManagementList;
        }
        int date[] = {Constant.ONEDAY, Constant.FIVEDAY, Constant.TWENTYDAY, Constant.ONEMONTH, Constant.THREEMONTHS, Constant.SIXMONTHS};
        List<ProfitManagement> list = new ArrayList<>();
        for (int i = 0; i < date.length; i++) {
            ProfitManagement profitManagement = new ProfitManagement();
            profitManagement.setId(IdUtil.simpleUUID());
            profitManagement.setFlowId(flowId);
            profitManagement.setMarketTime(date[i]);
            Random random = new Random();
            double randomValue = 0.01 + random.nextDouble() * 19.99; // 生成0到20之间的随机数（不包括0）
            BigDecimal stockPrice = BigDecimal.valueOf(randomValue).setScale(2, RoundingMode.HALF_UP); // 保留两位小数
            profitManagement.setStockPrice(stockPrice);
            profitManagementMapper.insert(profitManagement);
            list.add(profitManagement);
        }
        return list;
    }
}
