package com.sztzjy.fund_investment.service.serviceImpl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.sztzjy.fund_investment.entity.*;
import com.sztzjy.fund_investment.entity.treeSelect.TreeSelect;
import com.sztzjy.fund_investment.mapper.*;
import com.sztzjy.fund_investment.service.ISysFoundProjectService;
import com.sztzjy.fund_investment.service.ISysProjectDueDiligenceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class SysProjectDueDiligenceServiceImpl implements ISysProjectDueDiligenceService {
    @Autowired
    ISysFoundProjectService foundProjectService;
    @Autowired
    ProBusinessInfoShareholderMapper businessInfoShareholderMapper;
    @Autowired
    ProJudicialRiskMapper judicialRiskMapper;
    @Autowired
    ProBusinessRiskMapper businessRiskMapper;
    @Autowired
    ProCoreTeamMapper coreTeamMapper;
    @Autowired
    ProCoreBusinessMapper coreBusinessMapper;
    @Autowired
    ProCoreCompProMapper proCoreCompProMapper;
    @Autowired
    ProManaSituRecruitMapper proManaSituRecruitMapper;
    @Autowired
    ProManaSituCheckMapper proManaSituCheckMapper;
    @Autowired
    ProManaSituLicenseMapper proManaSituLicenseMapper;
    @Autowired
    ProManaSituTenderingBiddingMapper proManaSituTenderingBiddingMapper;
    @Autowired
    ProIntelPropertyPatentinfoMapper proIntelPropertyPatentinfoMapper;
    @Autowired
    ProIntelPropertyWebsiteRecordMapper proIntelPropertyWebsiteRecordMapper;
    @Autowired
    ProAdminiPenaltyMapper proAdminiPenaltyMapper;
    @Autowired
    FoundProjectMapper foundProjectMapper;
    @Autowired
    ProBusinessInfoMapper proBusinessInfoMapper;
    @Autowired
    ProFinancialIndexMapper proFinancialIndexMapper;
    @Autowired
    ProFinancialStatementMapper proFinancialStatementMapper;
    @Autowired
    ProFinancialIndexDetailMapper proFinancialIndexDetailMapper;
    @Autowired
    ProFinancialStatementDetailMapper proFinancialStatementDetailMapper;

    //公司背景-公司信息
    //先根据flowId查询项目池ID 根据项目池ID获取对应的数据
    @Override
    public List<ProBusinessInfoShareholder> getBusinessInfoShareholderListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProBusinessInfoShareholderExample example = new ProBusinessInfoShareholderExample();
        ProBusinessInfoShareholderExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProBusinessInfoShareholder> list = businessInfoShareholderMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProJudicialRisk> getProJudicialRiskListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProJudicialRiskExample example = new ProJudicialRiskExample();
        ProJudicialRiskExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProJudicialRisk> list = judicialRiskMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProBusinessRisk> getProBusinessRiskListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProBusinessRiskExample example = new ProBusinessRiskExample();
        ProBusinessRiskExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProBusinessRisk> list = businessRiskMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProCoreTeam> getProCoreTeamListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProCoreTeamExample example = new ProCoreTeamExample();
        ProCoreTeamExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProCoreTeam> list = coreTeamMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProCoreBusiness> getProCoreBusinessListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProCoreBusinessExample example = new ProCoreBusinessExample();
        ProCoreBusinessExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProCoreBusiness> list = coreBusinessMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProCoreCompPro> getProCoreCompProListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProCoreCompProExample example = new ProCoreCompProExample();
        ProCoreCompProExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProCoreCompPro> list = proCoreCompProMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProManaSituRecruit> getProManaSituRecruitListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProManaSituRecruitExample example = new ProManaSituRecruitExample();
        ProManaSituRecruitExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProManaSituRecruit> list = proManaSituRecruitMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProManaSituCheck> getProManaSituCheckListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProManaSituCheckExample example = new ProManaSituCheckExample();
        ProManaSituCheckExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProManaSituCheck> list = proManaSituCheckMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProManaSituLicense> getProManaSituLicenseListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProManaSituLicenseExample example = new ProManaSituLicenseExample();
        ProManaSituLicenseExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProManaSituLicense> list = proManaSituLicenseMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProManaSituTenderingBidding> getProManaSituTenderingBiddingListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProManaSituTenderingBiddingExample example = new ProManaSituTenderingBiddingExample();
        ProManaSituTenderingBiddingExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProManaSituTenderingBidding> list = proManaSituTenderingBiddingMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProIntelPropertyPatentinfo> getProIntelPropertyPatentInfoListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProIntelPropertyPatentinfoExample example = new ProIntelPropertyPatentinfoExample();
        ProIntelPropertyPatentinfoExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProIntelPropertyPatentinfo> list = proIntelPropertyPatentinfoMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProIntelPropertyWebsiteRecord> getProIntelPropertyWebsiteRecordListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProIntelPropertyWebsiteRecordExample example = new ProIntelPropertyWebsiteRecordExample();
        ProIntelPropertyWebsiteRecordExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProIntelPropertyWebsiteRecord> list = proIntelPropertyWebsiteRecordMapper.selectByExample(example);
        return list;
    }

    @Override
    public List<ProAdminiPenalty> getProAdminiPenaltyListByFlowId(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProAdminiPenaltyExample example = new ProAdminiPenaltyExample();
        ProAdminiPenaltyExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProAdminiPenalty> list = proAdminiPenaltyMapper.selectByExample(example);
        return list;
    }

    @Override
    public void updateServiceDueDiligence(FoundProject foundProject) {
        foundProjectMapper.updateByPrimaryKeySelective(foundProject);
    }

    @Override
    public List<ProBusinessInfo> getBusinessInfoList(String flowId) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        ProBusinessInfoExample example = new ProBusinessInfoExample();
        ProBusinessInfoExample.Criteria criteria = example.createCriteria();
        criteria.andProjectPoolIdEqualTo(projectPoolId);
        List<ProBusinessInfo> list = proBusinessInfoMapper.selectByExample(example);
        return list;
    }


    //返回财务指标选取树
    @Override
    public List<TreeSelect> getProFinancialIndexSelectTree() {
        List<ProFinancialIndex> financialIndexList=proFinancialIndexMapper.selectAll();
        List<TreeSelect> treeSelectList=new ArrayList<>();
        for (int i = 0; i < financialIndexList.size(); i++) {
            treeSelectList.add(new TreeSelect(financialIndexList.get(i)));
        }
        List<TreeSelect> treeSelects = TreeSelect.buildTree(treeSelectList);
        return treeSelects;
    }

    //返回财务报表选取树
    @Override
    public List<TreeSelect> getProFinancialStatementSelectTree() {
        List<ProFinancialStatement> financialStatementList=proFinancialStatementMapper.selectAll();
        List<TreeSelect> treeSelectList=new ArrayList<>();
        for (int i = 0; i < financialStatementList.size(); i++) {
            treeSelectList.add(new TreeSelect(financialStatementList.get(i)));
        }
        List<TreeSelect> treeSelects = TreeSelect.buildTree(treeSelectList);
        return treeSelects;
    }

    //财务指标详情查询
    //先根据flowid查询项目池id
    @Override
    public PageInfo<ProFinancialIndexDetail> selectProFinancialIndexDetailList(List<String> proFinancialIndexIdList,String flowId,Integer size,Integer index) {
        PageHelper.startPage(index, size);
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        List<ProFinancialIndexDetail> detailList = proFinancialIndexDetailMapper.selectByProFinancialIndexIdListAndProjectPoolId(proFinancialIndexIdList, projectPoolId);
        PageInfo<ProFinancialIndexDetail> pageInfo = new PageInfo<>(detailList);
        return pageInfo;
    }

    @Override
    public PageInfo<ProFinancialStatementDetail> selectProFinancialStatementDetailList(List<String> proFinancialStatementIdList, String flowId,Integer size,Integer index) {
        String projectPoolId = foundProjectService.selectProjectPoolIdByFlowId(flowId);
        List<ProFinancialStatementDetail> detailList=proFinancialStatementDetailMapper.selectByproFinancialStatementIdListAndProjectPoolId(proFinancialStatementIdList,projectPoolId);
        PageInfo<ProFinancialStatementDetail> pageInfo = new PageInfo<>(detailList);
        return pageInfo;
    }


}
