package com.sztzjy.fund_investment.service.tea;

import com.github.pagehelper.PageInfo;
import com.sztzjy.fund_investment.entity.TeaClassScore;
import com.sztzjy.fund_investment.entity.dto.*;
import com.sztzjy.fund_investment.util.ResultEntity;
import io.swagger.models.auth.In;
import org.springframework.http.HttpStatus;

import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Author xcj
 * @Date 2023/11/24
 */
public interface ClassScoreService {
    List<TeaClassScore> getClassAVGScore(String schoolId);

    TeaClassScoreDto getClassScoreCount(String schoolId, String classId, Date time);

    PageInfo<UserDto> getStudentScoreDetails(Integer index, Integer size, String schoolId, String classId, String studentIdOrName);

    void importExcel(HttpServletResponse response, String schoolId);

    ResultEntity<HttpStatus>  autoScore(String schoolId);

    PerformanceScoreDto getPerformanceScoreDto(String flowId);

    PerformanceTrainingScoreDto getStuTrainingScore(String performanceScoreId);

    FoundProjectDto getReportStringByFlowId(String flowId);

    ResultEntity<String> updateScoreByFlowId(String flowId, Map<String, Integer>map);

    void downloadReport(String reportId, HttpServletResponse response);

}
